type 'a heap

val moduleName : string

(** Categorial operations **)
(** Oprations catgorielles **)
(** Operaciones categoriales **)

val injection : 'a -> 'a heap
val map : ('a -> 'b) -> 'a heap -> 'b heap
val join : 'a heap heap -> 'a heap 
val plus : 'a heap -> 'a heap -> 'a heap
val zero : unit -> 'a heap

val from_list : 'a list -> 'a heap
val to_list : 'a heap -> 'a list

val make : int -> 'a -> 'a heap

(** Acces **)
(** Accs **)
(** Acceso **)

val insert : 'a -> 'a heap -> 'a heap
val insert_list : 'a list -> 'a heap -> 'a heap

val delete : 'a -> 'a heap -> 'a heap
val delete_all : 'a -> 'a heap -> 'a heap
val delete_min : 'a heap -> 'a heap
val delete_max : 'a heap -> 'a heap

val filter : ('a -> bool) -> 'a heap -> 'a heap

(** View **)
(** Vues **)
(** Vistas **)

val min_view : 'a heap -> 'a * 'a heap
val max_view : 'a heap -> 'a heap * 'a

val partition : ('a -> bool) -> 'a heap -> 'a heap * 'a heap

(** Observers **)
(** Observateurs **)
(** Observadores **)

val is_empty : 'a heap -> bool
val size : 'a heap -> int

val member : 'a -> 'a heap -> bool
val count : 'a -> 'a heap -> int

val min_element : 'a heap -> 'a
val max_element : 'a heap -> 'a

val exists : ('a -> bool) -> 'a heap -> bool
val for_all : ('a -> bool) -> 'a heap -> bool

(** Traversals **)
(** Parcours **)
(** Recorridos **)

val iter : ('a -> unit) -> 'a heap -> unit

val fold : ('a -> 'b -> 'b) -> 'a heap -> 'b -> 'b
val fold_right : ('a -> 'b -> 'b) -> 'a heap -> 'b -> 'b
val fold_left : ('a -> 'b -> 'a) -> 'a -> 'b heap -> 'a
