(* Diego Olivier Fernandez Pons
 * Universit Pierre et Marie Curie, Paris VI
 * diego-olivier.fernandez-pons@cicrp.jussieu.fr
 * 
 * AVL heap
 * Tas AVL
 * Monton AVL
 *
 *)

open BairePervasives

let moduleName = "AvlHeap"

type 'a heap = E | N of 'a heap * 'a * 'a heap * int


(** Utilitaires **)
(** Utils **)
(** tiles **)


let invalid = fun function_name error_type -> 
  invalid_argument moduleName function_name error_type

let makeTree = fun l v r -> 
  match (l, r) with
    | (E, E) -> N (l, v, r, 1)
    | (E, N (_, _, _, n)) -> N (r, v, l, n + 1)
    | (N (_, _, _, n), E) -> N (l, v, r, n + 1)
    | (N (_, _, _, m), N (_, _, _, n)) ->
	match compare n m with
	  | h when h < 0 -> N (r, v, l, n + 1)
	  | _ -> N (l, v, r, m + 1)


(** Categorial operations **)
(** Oprations catgorielles **)
(** Operaciones categoriales **)


let injection = function x -> makeTree E x E

let rec plus = fun a b ->
  match (a, b) with
    | (E, _) -> b
    | (_, E) -> a
    | (N (_, ax, x, bx), N (_, ay, y, by))  ->
	match compare x y with
	  | n when n < 0 -> makeTree ax x (plus bx b)
	  | _ -> makeTree ay y (plus a by)
	      

