type ('a, 'b) cartesian

val moduleName : string

(** Categorial operations **)
(** Oprations catgorielles **)
(** Operaciones categoriales **)

val injection : 'a -> 'b -> ('a, 'b) cartesian
val map : ('a -> 'b) -> ('a, 'c) cartesian -> ('b, 'c) cartesian
val join : (('a, 'b) cartesian, 'b) cartesian -> ('a, 'b) cartesian
val plus : ('a, 'b) cartesian -> ('a, 'b) cartesian -> ('a, 'b) cartesian
val zero : unit -> ('a, 'b) cartesian

val from_list : ('a * 'b) list -> ('a, 'b) cartesian
val to_list : ('a, 'b) cartesian -> ('a * 'b) list

val to_list_by_priority : ('a, 'b) cartesian -> ('a * 'b) list

(** Binary operations **)
(** Oprations binaires **)
(** Operaciones binrias **)

val union : ('a, 'b) cartesian -> ('a, 'b) cartesian -> ('a, 'b) cartesian
val intersection : ('a, 'b) cartesian -> ('a, 'b) cartesian -> 
  ('a, 'b) cartesian
val difference : ('a, 'b) cartesian -> ('a, 'b) cartesian -> ('a, 'b) cartesian
val symetric_difference : ('a, 'b) cartesian -> ('a, 'b) cartesian -> 
  ('a, 'b) cartesian

(** Acces **)
(** Accs **)
(** Acceso **)

val insert : 'a -> 'b -> ('a, 'b) cartesian -> ('a, 'b) cartesian
val insert' : 'a -> 'b -> ('a, 'b) cartesian -> ('a, 'b) cartesian

val delete : 'a -> ('a, 'b) cartesian -> ('a, 'b) cartesian
val delete_list : 'a list -> ('a, 'b) cartesian -> ('a, 'b) cartesian

val delete_min : ('a, 'b) cartesian -> ('a, 'b) cartesian
val delete_max : ('a, 'b) cartesian -> ('a, 'b) cartesian
val delete_max_priority : ('a, 'b) cartesian -> ('a, 'b) cartesian
val delete_min_priority : ('a, 'b) cartesian -> ('a, 'b) cartesian

val delete_raise : 'a -> ('a, 'b) cartesian -> ('a, 'b) cartesian 
  (* [Not_found] *)

val filter : ('a -> 'b -> bool) -> ('a, 'b) cartesian -> ('a, 'b) cartesian
val filter_lt : 'a -> ('a, 'b) cartesian -> ('a, 'b) cartesian
val filter_gt : 'a -> ('a, 'b) cartesian -> ('a, 'b) cartesian
val filter_le : 'a -> ('a, 'b) cartesian -> ('a, 'b) cartesian
val filter_ge : 'a -> ('a, 'b) cartesian -> ('a, 'b) cartesian

val range : 'a -> 'a -> ('a, 'b) cartesian -> ('a, 'b) cartesian

(** View **)
(** Vues **)
(** Vistas **)

val min_view : ('a, 'b) cartesian -> ('a * 'b) * ('a, 'b) cartesian 
  (* [Empty] *)
val max_view : ('a, 'b) cartesian -> ('a, 'b) cartesian * ('a * 'b)
  (* [Empty] *)
val max_priority_view : ('a, 'b) cartesian -> ('a * 'b) * ('a, 'b) cartesian
  (* [Empty] *)
val min_priority_view : ('a, 'b) cartesian -> ('a, 'b) cartesian * ('a * 'b)
  (* [Empty] *)

val partition_inf_sup : 'a -> ('a, 'b) cartesian ->
  ('a, 'b) cartesian * ('a * 'b) option * ('a, 'b) cartesian

val partition : ('a -> 'b -> bool) -> ('a, 'b) cartesian -> 
  ('a, 'b) cartesian * ('a, 'b) cartesian

(** Observers **)
(** Observateurs **)
(** Observadores **)

val is_empty : ('a, 'b) cartesian -> bool
val size : ('a, 'b) cartesian -> int

val member' : 'a -> ('a, 'b) cartesian -> bool
val member : 'a -> ('a, 'b) cartesian -> bool
val find : ('a -> bool) -> ('a, 'b) cartesian -> 'a (* [Not_found] *)

val choose : ('a, 'b) cartesian -> 'a (* [Empty] *)
val min_element  : ('a, 'b) cartesian -> 'a * 'b (* [Not_found] *)
val max_element  : ('a, 'b) cartesian -> 'a * 'b (* [Not_found] *)
val min_priority : ('a, 'b) cartesian -> 'a * 'b (* [Not_found] *)
val max_priority : ('a, 'b) cartesian -> 'a * 'b (* [Not_found] *)

val next     : 'a -> ('a, 'b) cartesian -> 'a * 'b (* [Not_found] *)
val previous : 'a -> ('a, 'b) cartesian -> 'a * 'b (* [Not_found] *)
val ceil     : 'a -> ('a, 'b) cartesian -> 'a * 'b (* [Not_found] *)
val floor    : 'a -> ('a, 'b) cartesian -> 'a * 'b (* [Not_found] *)

val rank : 'a -> ('a, 'b) cartesian -> int (* [Not_found] *)
val get : int -> ('a, 'b) cartesian -> 'a * 'b (* [Out_of_bounds] *)

val for_all : ('a -> 'b -> bool) -> ('a, 'b) cartesian -> bool
val exists  : ('a -> 'b -> bool) -> ('a, 'b) cartesian -> bool

(** Traversals **)
(** Parcours **)
(** Recorridos **)

val iter : ('a -> 'b -> 'c) -> ('a, 'b) cartesian -> unit

val fold_left  : ('c -> 'a -> 'b -> 'c) -> 'c -> ('a, 'b) cartesian -> 'c
val fold_right : ('a -> 'b -> 'c -> 'c) -> ('a, 'b) cartesian -> 'c -> 'c
val fold : ('a -> 'b -> 'c -> 'c) -> ('a, 'b) cartesian -> 'c -> 'c

(** Miscellaneous **)
(** Divers **)
(** Micelanios **)

val old_plus : ('a, 'b) cartesian -> ('a, 'b) cartesian -> ('a, 'b) cartesian

val bind : 
  ('a, 'b) cartesian -> ('a -> ('c, 'd) cartesian) -> ('c, 'd) cartesian

val concat_map :
  ('a -> ('b, 'c) cartesian) -> ('a, 'd) cartesian -> ('b, 'c) cartesian

val unsafe_set : 'a -> 'b -> int -> ('a, 'b) cartesian -> ('a, 'b) cartesian

(** Compatibility with the standard Caml library **)
(** Compatibilit avec la librairie standard **)
(** Compatibilidad con la librera estandar **)

val empty : ('a, 'b) cartesian
val mem : 'a -> ('a, 'b) cartesian -> bool
val add : 'a -> 'b -> ('a, 'b) cartesian -> ('a, 'b) cartesian
val singleton : 'a -> 'b -> ('a, 'b) cartesian
val remove : 'a -> ('a, 'b) cartesian -> ('a, 'b) cartesian
val inter : ('a, 'b) cartesian -> ('a, 'b) cartesian -> ('a, 'b) cartesian
val diff : ('a, 'b) cartesian -> ('a, 'b) cartesian -> ('a, 'b) cartesian
val cardinal : ('a, 'b) cartesian -> int
val elements : ('a, 'b) cartesian -> ('a * 'b) list
val min_elt : ('a, 'b) cartesian -> 'a * 'b
val max_elt : ('a, 'b) cartesian -> 'a * 'b

