type ('a, 'b) priorityQueue

val moduleName : string

(** Categorial operations **)
(** Oprations catgorielles **)
(** Operaciones categoriales **)

val injection : 'a -> 'b -> ('a, 'b) priorityQueue

val map : ('a * 'b-> 'c * 'd) -> ('a, 'b) priorityQueue -> 
  ('c, 'd) priorityQueue

val plus : ('a, 'b) priorityQueue -> ('a, 'b) priorityQueue -> 
  ('a, 'b) priorityQueue

val zero : unit -> ('a, 'b) priorityQueue

val from_list : ('a * 'b) list -> ('a, 'b) priorityQueue
val to_list : ('a, 'b) priorityQueue -> ('a * 'b) list

(** Acces **)
(** Accs **)
(** Acceso **)

val insert : 'a -> 'b -> ('a, 'b) priorityQueue -> ('a, 'b) priorityQueue
val insert_list : ('a * 'b) list -> ('a, 'b) priorityQueue

val delete_min : ('a, 'b) priorityQueue -> ('a, 'b) priorityQueue

val filter : ('a -> 'b -> bool) -> ('a, 'b) priorityQueue -> 
  ('a, 'b) priorityQueue

(** View **)
(** Vues **)
(** Vistas **)

val min_view : ('a, 'b) priorityQueue -> 'a * 'b * ('a, 'b) priorityQueue

val partition : ('a -> 'b -> bool) -> 
 ('a, 'b) priorityQueue -> ('a, 'b) priorityQueue * ('a, 'b) priorityQueue

(** Observers **)
(** Observateurs **)
(** Observadores **)

val is_empty : ('a, 'b) priorityQueue  -> bool
val size : ('a, 'b) priorityQueue -> int

val member_priority : 'a -> ('a, 'b) priorityQueue -> bool
val count_priority : 'a -> ('a, 'b) priorityQueue -> int

val min_element : ('a, 'b) priorityQueue -> 'a * 'b

val exists  : ('a -> 'b -> bool) -> ('a, 'b) priorityQueue -> bool
val for_all : ('a -> 'b -> bool) -> ('a, 'b) priorityQueue -> bool

(** Traversals **)
(** Parcours **)
(** Recorridos **)

val iter : ('a -> 'b -> unit) -> ('a, 'b) priorityQueue -> unit

val fold : ('a -> 'b -> 'c -> 'c) -> ('a, 'b) priorityQueue -> 'c -> 'c
val fold_left : ('c -> 'a -> 'b -> 'c) -> 'c -> ('a, 'b) priorityQueue -> 'c
val fold_right : ('a -> 'b -> 'c -> 'c) -> ('a, 'b) priorityQueue -> 'c -> 'c

