type 'a seq

val copy : 'a seq -> 'a seq

val unit : 'a -> 'a seq
val map : ('a -> 'b) -> 'a seq -> 'b seq
val join : 'a seq seq -> 'a seq
val plus : 'a seq -> 'a seq -> 'a seq
val zero : unit -> 'a seq
val make : int -> 'a -> 'a seq
val get : int -> 'a seq -> 'a
val set : int -> 'a -> 'a seq -> 'a seq

val cons : 'a -> 'a seq -> 'a seq
val snoc : 'a seq -> 'a -> 'a seq
val init : int -> (int -> 'a) -> 'a seq
val from_list : 'a list -> 'a seq

val left_view : 'a seq -> 'a * 'a seq
val left_head : 'a seq -> 'a
val left_tail : 'a seq -> 'a seq
val right_view : 'a seq -> 'a seq * 'a
val right_head : 'a seq -> 'a
val right_tail : 'a seq -> 'a seq

val is_empty : 'a option ref -> bool
val size : 'a seq -> int
val to_list : 'a seq -> 'a list

val reverse : 'a seq -> 'a seq

val iter : ('a -> unit) -> 'a seq -> unit
val for_all : ('a -> bool) -> 'a seq -> bool
val exists : ('a -> bool) -> 'a seq -> bool
val find : ('a -> bool) -> 'a seq -> 'a
val filter : ('a -> bool) -> 'a seq -> 'a seq

val fold_left : ('a -> 'b -> 'a) -> 'a -> 'b seq -> 'a
val fold_right : ('a -> 'b -> 'b) -> 'b -> 'a seq -> 'b

val map_with_index :  (int -> 'a -> 'a) -> 'a seq -> 'a seq

val adjust : ('a -> 'a) -> 'a seq -> unit
val plus_side : 'a seq -> 'a seq -> unit
val join_side : 'a seq seq -> unit
val set_side : int -> 'a -> 'a seq -> unit

val insert_left : 'a -> 'a seq -> unit
val insert_right : 'a seq -> 'a -> unit
val delete_left : 'a seq -> unit
val delete_right : 'a seq -> unit

val adjust_with_index : (int -> 'a -> 'a) -> 'a seq -> unit

