type 'a seq

val unit : 'a -> 'a seq
val map : ('a -> 'b) -> 'a seq -> 'b seq
val plus : 'a seq -> 'a seq -> 'a seq
val zero : unit -> 'a list
val get : int -> 'a seq -> 'a
val set : int -> 'a -> 'a seq -> 'a seq

val cons : 'a -> 'a seq -> 'a seq
val from_list : 'a list -> 'a seq

val left_view : 'a seq  -> 'a * 'a seq
val left_head : 'a seq -> 'a
val left_tail : 'a seq -> 'a seq
val right_head : 'a seq -> 'a

val is_empty : 'a list -> bool
val size : 'a seq -> int

val to_list : 'a seq -> 'a list
