type 'a seq

val unit : 'a -> 'a seq
val map : ('a -> 'b) -> 'a seq -> 'b seq
val get : int -> 'a seq -> 'a
val set : int -> 'a -> 'a seq -> 'a seq

val cons : 'a -> 'a seq -> 'a seq
val from_list : 'a list -> 'a seq

val left_view : 'a seq -> 'a * 'a seq
val left_tail : 'a seq -> 'a seq
val left_head : 'a seq -> 'a
val right_head : 'a seq -> 'a

val is_emtpy : 'a seq -> bool
val size : 'a seq -> int
val to_list : 'a seq -> 'a list

val reverse_onto : 'a seq -> 'a seq -> 'a seq

val fold_right : ('a -> 'b -> 'a) -> 'a -> 'b seq -> 'a
val fold_left : ('a -> 'b -> 'a) -> 'a -> 'b seq -> 'a
