(* Diego Olivier Fernandez Pons
 * Universit Pierre et Marie Curie, Paris VI
 * diego-olivier.fernandez-pons@cicrp.jussieu.fr
 * 
 * Unbalanced discrete interval encoding tree (diet)
 * Arbre d'intervales discrets non quilibr
 * rbol de intervalos discretos no equilibrado
 * 
 *)

open BairePervasives

let moduleName = "UnbalancedDiet"

type 'a set = 
  | E
  | S of 'a set * 'a * 'a set
  | I of 'a set * 'a * 'a * 'a set


(** Utils **)
(** Utilitaires **)
(** tiles **)

let successive = fun x y -> succ x = y

let invalid = fun function_name error_type -> 
  invalid_argument moduleName function_name error_type

let makeSingle = fun l v r ->
  let l =
    try let (min_l, max_l) = max_interval l in
      if successive max_l v then delete_max_interval l
      else l
      
  in
    match (successive max_left v, succesive v min_right) with
      | (false, false) -> S (l, v, r)
      | (false, true) ->
	  let (min, max, right) = append_left v r in I (l, min, max, right)
      | (true, false) ->
	  let (left, min, max) = append_right v l in I (left, min, max, r)
      | (true, true) -> 
	  let 
	    (left, min, _) = append_right v l and
	    (_, max, right) = append_left v r
	  in
	    I (left, min, max, right)
 
