type intSet

val moduleName : string

(** Categorial operations **)
(** Oprations catgorielles **)
(** Operaciones categoriales **)

val injection : int -> intSet
val map : (int -> int) -> intSet -> intSet
val plus : intSet -> intSet -> intSet
val zero : unit -> intSet

val from_list : int list -> intSet
val to_list : intSet -> int list

val from_tree : int BairePervasives.tree -> intSet

(** Binary operations **)
(** Oprations binaires **)
(** Operaciones binrias **)

val union        : intSet -> intSet -> intSet
val intersection : intSet -> intSet -> intSet
val difference   : intSet -> intSet -> intSet

val subset  : intSet -> intSet -> bool
val equal   : intSet -> intSet -> bool
val compare : intSet -> intSet -> int

(** Acces **)
(** Accs **)
(** Acceso **)

val insert : int -> intSet -> intSet
val delete : int -> intSet -> intSet

val insert_list : int list -> intSet -> intSet
val delete_list : int list -> intSet -> intSet

val insert_raise : int -> intSet -> intSet (* [Found] *)
val delete_raise : int -> intSet -> intSet (* [Not_found] *)

(** Observers **)
(** Observateurs **)
(** Observadores **)

val is_empty : intSet -> bool
val size : intSet -> int

val member  : int -> intSet -> bool

(** Traversals **)
(** Parcours **)
(** Recorridos **)

val iter : (int -> unit) -> intSet -> unit

(** Compatibility with the standard Caml library **)
(** Compatibilit avec la librairie standard **)
(** Compatibilidad con la librera estandar **)

val empty : intSet
val mem : int -> intSet -> bool
val add : int -> intSet -> intSet
val singleton : int -> intSet
val remove : int -> intSet -> intSet
val inter : intSet -> intSet -> intSet
val diff : intSet -> intSet -> intSet
val cardinal : intSet -> int
val elements : intSet -> int list

(** Debug **)

val stat : intSet -> int * int * int * int
