(* Diego Olivier Fernandez Pons
 * Universit Pierre et Marie Curie, Paris VI
 * diego-olivier.fernandez-pons@cicrp.jussieu.fr
 * 
 * Digital search tree (digital trie)
 * Trie binaire avec regroupement de bits dans les feuilles
 * Arbol de busqueda por digitos
 *)

open BairePervasives

type set =
  | E
  | Leaf of int
  | ZLeaf of int
  | Node of set * int * set
  | ZNode of set * int * set
  | Prefix of int * set


(** Utilitaires **)
(** Utils **)
(** tiles **)


let moduleName = "OrderedDigitalTrie"

let block_size = 32
let block_mask = lnot 31 (* 0000111111111111111111111111111b *)

let invalid = fun function_name error_type -> 
  invalid_argument moduleName function_name error_type

let prefix = function n -> n land block_mask
let mask = function n -> 1 lsl (n - 1)

let rec injection = function
  | 0 -> ZLeaf 0
  | n when n < block_size -> Leaf (mask n)
  | n -> Prefix (prefix n, injection (n mod 32))

let rec insert = fun n trie ->
  if n = 0 then 
    match trie with
      | E -> ZLeaf 0
      | Leaf m -> ZLeaf m
      | Node (l, m, r) -> ZNode (l, m, r)
      | Prefix (p, t) -> 
